(* CS421 - Fall 2017
 * letrec
 *
 * Please keep in mind that there may be more than one
 * way to solve a problem.  You may want to change how this starts.
 *)

open Common
open Plsolution

(* Problem 5 *)
let rec cps_exp e k = 
   match e with 
(*[[x]]k = k x*)
     VarExp x -> cps_exp_VarExp x k cps_exp
(*[[c]]k = k x*)
   | ConstExp n -> cps_exp_ConstExp n k cps_exp
(*[[~ e]]k = [[e]]_(fun r -> k (~ r)) *)
   | MonOpAppExp (m, e) -> cps_exp_MonOpAppExp (m, e) k cps_exp
(*[[(e1 + e2)]]k = [[e2]]_ fun s -> [[e1]] _ fun r -> k (r + s)*)
   | BinOpAppExp (b, e1, e2) -> cps_exp_BinOpAppExp (b, e1, e2) k cps_exp
(*[[if e1 then e2 else e3]]k = [[e1]]_(fun r -> if r then [[e2]]k else [[e3]]k)*)
   | IfExp (e1,e2,e3) -> cps_exp_IfExp (e1,e2,e3) k cps_exp
(*[[e1 e2]]k = [[e2]]_fun v2 -> [[e1]]_fun v1 -> k (v1 v2)*)
   | AppExp (e1,e2) -> cps_exp_AppExp (e1,e2) k cps_exp
(*[[fun x -> e]]k = k(fnk x kx -> [[e]]kx) *)
   | FunExp (x,e) -> cps_exp_FunExp (x,e) k cps_exp
(*[[let x = e1 in e2]]k = [[e1]]_fun x -> [[e2]]k) *)
   | LetInExp (x,e1,e2) -> cps_exp_LetInExp (x,e1,e2) k cps_exp

(* Remove the raise and put your code where the raise is now. *)
(*[[let rec f x = e1 in e2]]k =
  (FN f -> [[e2]]_k))(FIX f. FUN x -> fn kx => [[e1]]kx) *)
   | LetRecInExp(f,x,e1,e2) -> raise (Failure "Not implemented yet")
